(function()
{
	//decodes a string
	this.decodeUTF8 = function(aString)
	{
		if(aString.indexOf('%') == -1)
			return aString;
		try
		{
			return decodeURIComponent(aString);
		}
		catch(e)
		{
			try
			{
				return decodeURI(aString);
			}
			catch(e)
			{
				return aString;
			}
		}
	};
	//encodes a URI - Example: converts this http://www.dmoz.org/World/Español/ to  http://www.dmoz.org/World/Espa%C3%B1ol/
	this.encodeURI = function(aURI)
	{
		try
		{
			return encodeURI(aURI);
		}
		catch(e)
		{
			return aURI;
		}
	};
	//encodes a string
	this.encodeUTF8 = function(aString)
	{
		try
		{
			return encodeURIComponent(aString);
		}
		catch(e)
		{
			try
			{
				return encodeURI(aString);
			}
			catch(e)
			{
				return aString;
			}
		}
	};
	//Decodes HTML special chars
	this.htmlSpecialCharsDecode = function(aString)
	{
		return aString.split('&lt;').join('<').split('&gt;').join('>').split('&quot;').join('"').split('&apos;').join("'").split('&amp;').join('&');
	}
	//cast an object toString avoids null errors
	this.string = function(aString)
	{
		if(!aString)
			return '';
		else
			return aString.toString();
	};
	//stripTags from a string
	this.stripTags = function(aString, aReplacement)
	{
		if(!aString)
			return '';
		if(!aReplacement)
			return aString.replace(/<[^>]*>/g, '');
		else
			return aString.replace(/<[^>]*>/g, aReplacement);
	};
	//trims a string
	this.trim = function(aString)
	{
		if(!aString)
			return '';
		return aString.replace(/^\s+/, '').replace(/\s+$/, '');
	};

	return null;

}).apply(ptmenu);
