(function()
{
	//returns true if the URI is safe to use
	this.isSecureURI = function(aURI)
	{
		var aURI = this.string(aURI).toLowerCase();
		
		if(
			   aURI.indexOf('http://') === 0 || 
			   aURI.indexOf('https://') === 0 ||
			   aURI.indexOf('ftp://') === 0 ||
			   aURI.indexOf('feed:') === 0 ||
			   aURI.indexOf('gopher:') === 0
		   )
		{
			return true;
		}
		else
		{
			this.error(' The URI "'+aURI+'" can\'t be opened, looks like a non secure URI for use within this extension');
			return false;
		}
	}
	//opens a an URL that is already encoded example:http://www.dmoz.org/World/Espa%C3%B1ol/ 
	//if allowed and selected: in a sub browser of split browser extension, at the desired position
	//else in a normal tab, selected or not
	this.openURL = function(aURL, inNewTab, inNewWindow, giveFocus, onSubBrowser, subBrowserPosition, aPostData)
	{
		//security
		if(this.isSecureURI(aURL))
		{
			if(inNewWindow && !inNewTab)//err! this is not fun!
			{
				if(!aPostData)
					window.open(aURL);
				else
				{
					if(this.isSeaMonkey())
						window.openDialog('chrome://navigator/content', '_blank', 'all,dialog=no', aURL, null, null, this.postData(aPostData));
					else
						window.openDialog('chrome://browser/content', '_blank', 'all,dialog=no', aURL, null, null, this.postData(aPostData));
				}
			}
			else
			{
				//if the user allowed the usage of other add-ons and if is there
				if(onSubBrowser && this.isThereSplitBrowser() && this.usePowerExtensionsWhenAvailable)
				{
						try{
							//find the position of the split browser
								var aPosition;
								if(subBrowserPosition == 'L')
									aPosition = SplitBrowser.POSITION_LEFT
								else if(subBrowserPosition == 'R')
									aPosition = SplitBrowser.POSITION_RIGHT
								else if(subBrowserPosition == 'T')
									aPosition = SplitBrowser.POSITION_TOP
								else if(subBrowserPosition == 'B')
									aPosition = SplitBrowser.POSITION_BOTTOM
									
							//check if there subbrowser is already opened
							if(!this.aSubBrowser || !this.aSubBrowser[subBrowserPosition] || !this.aSubBrowser[subBrowserPosition].browser)
							{
								if(!this.aSubBrowser)
									this.aSubBrowser = [];
	
								this.aSubBrowser[subBrowserPosition] = SplitBrowser.addSubBrowser('', SplitBrowser.activeBrowser, aPosition);
								this.aSubBrowser[subBrowserPosition].browser.loadURIWithFlags(aURL, null, null, null, this.postData(aPostData) )
							}
							else
							{
								if(inNewTab)
								{
									var aTab = this.aSubBrowser[subBrowserPosition].browser.addTab(aURL, null, null, this.postData(aPostData));
									
									if(giveFocus)
									{
										this.aSubBrowser[subBrowserPosition].browser.focus();
										this.aSubBrowser[subBrowserPosition].browser.selectedTab = aTab;
									}
								}
								else
								{
									this.aSubBrowser[subBrowserPosition].browser.loadURIWithFlags(aURL, null, null, null, this.postData(aPostData) )
								}
							}
							return;
							
						}catch(e){}
				}
				//if split browser is not there, or if is usage of the power extensions is disabled ,or if fails
				// open a normal tab
				if(inNewTab && this.documentFocusedGetLocation() != 'about:blank')
					this.tabOpen(aURL, giveFocus, aPostData);
				else
					gBrowser.loadURIWithFlags(aURL, null, null, null, this.postData(aPostData))
			}
		}
	}
	//returns .. post data in a what???
	this.postData = function(dataString)
	{
		if(!dataString)
			return null;
		// POST method requests must wrap the encoded text in a MIME
		// stream
		var stringStream = Components.classes["@mozilla.org/io/string-input-stream;1"].
						   createInstance(Components.interfaces.nsIStringInputStream);
		if ("data" in stringStream) // Gecko 1.9 or newer
		  stringStream.data = dataString;
		else // 1.8 or older
		  stringStream.setData(dataString, dataString.length);
		
		var postData = Components.classes["@mozilla.org/network/mime-input-stream;1"].
					   createInstance(Components.interfaces.nsIMIMEInputStream);
		postData.addHeader("Content-Type", "application/x-www-form-urlencoded");
		postData.addContentLength = true;
		postData.setData(stringStream);
		
		// postData is ready to be used as aPostData argument
		return postData;
	}

	return null;

}).apply(ptmenu);
