/* ***** BEGIN LICENSE BLOCK *****
 *   Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is PassiveRecon.
 *
 * The Initial Developer of the Original Code is
 * Justin Morehouse.
 * Portions created by the Initial Developer are Copyright (C) 2008
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * Gina Trapani
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 * 
 * ***** END LICENSE BLOCK ***** */

var passiverecon = {
  onLoad: function() {
    // initialization code
    this.initialized = true;
    this.strings = document.getElementById("passiverecon-strings");
    //document.getElementById("contentAreaContextMenu").addEventListener("popupshowing", function(e) { this.showContextMenu(e); }, false);
  },

  showContextMenu: function(event) {
    // show or hide the menuitem based on what the context menu is on
    // see http://kb.mozillazine.org/Adding_items_to_menus
    document.getElementById("context-passiverecon").hidden = gContextMenu.onImage;
  },
  onMenuItemCommand: function(e) {
    var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                                  .getService(Components.interfaces.nsIPromptService);
    promptService.alert(window, this.strings.getString("helloMessageTitle"),
                                this.strings.getString("helloMessage"));
  },
  getWebServiceArray: function () {
    var ws = new Object();
    
	// DNS
	ws['intodns']				= 'http://www.intodns.com/';
	ws['robtex-root'] 			= 'http://www.robtex.com/dns/';
	ws['robtex-www'] 			= 'http://www.robtex.com/dns/';
	
	// Email
	// ws['emailstuff-mx'] 		= 'http://emailstuff.org/dns/mx/'; *** Down as of 9/14/10 ***
	ws['hashemian'] 			= 'http://www.hashemian.com/tools/domain-email.php?b=';
	
	// Enumeration
	ws['netcraft-sitereport'] 	= 'http://toolbar.netcraft.com/site_report?url=http://';
    ws['netcraft-siterunning'] 	= 'http://uptime.netcraft.com/up/graph/?host=';
	
	// Google
	ws['google-pdf'] 			= 'http://www.google.com/search?hl=en&q=filetype%3Apdf+site%3A';
	ws['google-email'] 			= 'http://www.google.com/search?q=+%22%40'+this.getDocument().document.domain.replace('www.', '')+'%22+-';
	ws['google-groups']			= 'http://groups.google.com/groups/search?lr=&safe=off&num=10&q=';
	ws['google-link'] 			= 'http://www.google.com/search?q=link:';
	ws['google-xls'] 			= 'http://www.google.com/search?hl=en&q=filetype%3Axls+OR+filetype%3Axlsx+site%3A';
	ws['google-ppt'] 			= 'http://www.google.com/search?hl=en&q=filetype%3Appt+OR+filetype%3Apptx+site%3A';	
	ws['google-doc'] 			= 'http://www.google.com/search?hl=en&q=filetype%3Adoc+OR+filetype%3Adocx+site%3A';
	ws['google-2003']			= 'http://www.google.com/search?h1=en&q=filetype%3Axls+OR+filetype%3Appt+OR+filetype%3Adoc+site%3A';
	ws['google-2007']			= 'http://www.google.com/search?h1=en&q=filetype%3Axlsx+OR+filetype%3Apptx+OR+filetype%3Adocx+site%3A';
	ws['google-rtf'] 			= 'http://www.google.com/search?hl=en&q=filetype%3Artf+site%3A';
	ws['google-site'] 			= 'http://www.google.com/search?hl=en&q=site%3A'+this.getDocument().document.domain.replace('www.', '')+'+-';
	ws['google-txt'] 			= 'http://www.google.com/search?hl=en&q=filetype%3Atxt+site%3A';
		
	// IP
	ws['centralops-dd']			= 'http://centralops.net/co/DomainDossier.aspx?dom_whois=true&dom_dns=true&traceroute=true&net_whois=true&svc_scan=true&x=15&y=11&addr=';
	ws['networktools-nl'] 		= 'http://network-tools.com/default.asp?prog=network&host=';
	ws['networktools-tr'] 		= 'http://network-tools.com/default.asp?prog=trace&host=';

	// Whois
	ws['domaintools'] 			= 'http://whois.domaintools.com/';
	// ws['samspade'] 				= 'http://samspade.org/whois/'; *** Down as of 9/14/10 ***

    return ws;
  },
  goToWebService: function (wsname) {
    ws = this.getWebServiceArray();
	if (wsname == 'centralops-dd')
	{
		this.goTo(ws[wsname]+this.getDocument().document.domain.replace('www.', ''));
	}
	// else if (wsname == 'emailstuff-mx') *** Down as of 9/14/10 ***
	// {
	//     this.goTo(ws[wsname]+this.getDocument().document.domain.replace('www.', ''));
	// }
	else if (wsname == 'google-groups')
	{
	    this.goTo(ws[wsname]+this.getDocument().document.domain.replace('www.', ''));
	}
	else if (wsname == 'hashemian')
	{
	    this.goTo(ws[wsname]+this.getDocument().document.domain.replace('www.', ''));
	}
	else if (wsname == 'intodns')
	{
	    this.goTo(ws[wsname]+this.getDocument().document.domain.replace('www.', ''));
	}
	else if (wsname == 'robtex-root')
	{
	    this.goTo(ws[wsname]+this.getDocument().document.domain.replace('www.', '')+'.html');
	}
	else if (wsname == 'robtex-www')
	{
	    this.goTo(ws[wsname]+this.getDocument().document.domain+'.html');
	}
	// else if (wsname == 'samspade') *** Down as of 9/14/10 ***
	// {
	//     this.goTo(ws[wsname]+this.getDocument().document.domain.replace('www.', ''));
	// }
	else {
	    this.goTo(ws[wsname]+this.getDocument().document.domain);
	}
  },
  getDocument: function () { 
    return window._content;
  },
  goTo: function (url) {
    openNewTabWith(url, null, null, false);
  },
  goToAllWebServices: function() {
    ws = this.getWebServiceArray();
	var curSite = this.getDocument().document.domain;
    for (service in ws) {
//      this.goTo(ws[service]+curSite);
		if (service == 'centralops-dd')
		{
		    this.goTo(ws[service]+this.getDocument().document.domain.replace('www.', ''));
		}
		// else if (service == 'emailstuff-mx') *** Down as of 9/14/10 ***
		// {
		//     this.goTo(ws[service]+this.getDocument().document.domain.replace('www.', ''));
		// }
		else if (service == 'google-groups')
		{
		    this.goTo(ws[service]+this.getDocument().document.domain.replace('www.', ''));
		}
		else if (service == 'hashemian')
		{
		    this.goTo(ws[service]+this.getDocument().document.domain.replace('www.', ''));
		}
		else if (service == 'intodns')
		{
		    this.goTo(ws[service]+this.getDocument().document.domain.replace('www.', ''));
		}
		else if (service == 'robtex-root')
		{
		    this.goTo(ws[service]+this.getDocument().document.domain.replace('www.', '')+'.html');
		}
		else if (service == 'robtex-www')
		{
		    this.goTo(ws[service]+curSite+'.html');
		}
		// else if (service == 'samspade') *** Down as of 9/14/10 ***
		// {
		//     this.goTo(ws[service]+this.getDocument().document.domain.replace('www.', ''));
		// }
		else {
		    this.goTo(ws[service]+curSite);
		}
    }
  }
};

window.addEventListener("load", function(e) { passiverecon.onLoad(e); }, false);


