var proxyToolHTTPListener = {
	prefManager : Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch),
	
	isPreferenceSet: function(preference) {
		if (preference) {
			return proxyToolHTTPListener.prefManager.prefHasUserValue(preference);
		}
		return false;
	},
	
	observe: function(subject, topic, data) {
    	if (topic == "http-on-modify-request") {
        	var referer = proxyToolHTTPListener.isPreferenceSet("extensions.proxytool.referer") ? proxyToolHTTPListener.prefManager.getCharPref("extensions.proxytool.referer") : "";
          	if (referer != "default") {
          		if (referer == "random")
					referer = proxyToolHTTPListener.prefManager.getCharPref("extensions.proxytool.random_referer");
				if (referer == "rotate")
					referer = proxyToolHTTPListener.prefManager.getCharPref("extensions.proxytool.rotate_referer");
          	
          		var httpChannel = subject.QueryInterface(Components.interfaces.nsIHttpChannel);		
          		httpChannel.setRequestHeader("Referer", referer, false);
          	}
          	return;
		}
		if (topic == "app-startup") {
        	var os = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
          	os.addObserver(this, "http-on-modify-request", false);   
	        return;
      	}
  	},
 
	QueryInterface: function (iid) {
    	if (iid.equals(Components.interfaces.nsIObserver) ||
            iid.equals(Components.interfaces.nsISupports))
            return this;      
        Components.returnCode = Components.results.NS_ERROR_NO_INTERFACE;
        return null;
    }
};

var proxyToolModule = {
	registerSelf: function (compMgr, fileSpec, location, type) {
		var compMgr = compMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
        compMgr.registerFactoryLocation(this.ptCID, this.ptName, this.ptProgID, fileSpec, location, type);

        var catMgr = Components.classes["@mozilla.org/categorymanager;1"].getService(Components.interfaces.nsICategoryManager);
        catMgr.addCategoryEntry("app-startup", this.ptName, this.ptProgID, true, true);
    },


    getClassObject: function (compMgr, cid, iid) {
        return this.ptFactory;
    },

    ptCID: Components.ID("{bf455260-b2aa-11df-94e2-0800200c9a66}"),

    ptProgID: "@proxylist.co/proxytool;1",

    ptName:   "Proxy Tool",

    ptFactory: {
    	QueryInterface: function (aIID) {
            if (!aIID.equals(Components.interfaces.nsISupports) &&
                !aIID.equals(Components.interfaces.nsIFactory))
                throw Components.results.NS_ERROR_NO_INTERFACE;
            return this;
        },

        createInstance: function (outer, iid) {
        	return proxyToolHTTPListener.QueryInterface(iid);
        }
    },

    canUnload: function(compMgr) {
        return true;
    }
};

function NSGetModule(compMgr, fileSpec) {
	return proxyToolModule;
}