//XXX add license

if(!com) var com={};
if(!com.example) com.example={};
if(!com.example.stackedinspector) com.example.stackedinspector={};

com.example.stackedinspector = {

  // not really constants but let's pretend
  kOrientHorz       : "horizontal",
  kOrientVert       : "vertical",
  kPrefBranch       : "extensions.stackedinspector.",
  kPrefAtom         : "orientation",
  kDOMIContainerID  : "bxPanelSet",
  kSplitterID       : "splPanels",
  kAttrOrient       : "orient",
  kAttrOrientVert   : "vertical",

  orientation: this.kOrientHorz,
  
  onLoad: function() {
    // initialization code
    var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    prefs = prefs.getBranch(this.kPrefBranch);
    this.orientation = prefs.getCharPref(this.kPrefAtom);
    // if not found or unrecognized value, restore default
    if(this.orientation != this.kOrientHorz && this.orientation != this.kOrientVert) {
      prefs.setCharPref(this.kPrefAtom,this.kOrientHorz);
      this.orientation = this.kOrientHorz;
    }
    document.getElementById(this.kDOMIContainerID).style.MozBoxOrient = this.orientation;
    this.reorientSplitter(this.orientation);
  },
  
  onUnload: function() {
    // shutdown code - save state in pref to restore next time a domi window is opened
    // if multiple domi windows, saved state will reflect last one closed
    var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    prefs = prefs.getBranch(this.kPrefBranch);
    prefs.setCharPref(this.kPrefAtom,this.orientation);
  },
  
  onToolbarButtonCommand: function(e) {
    this.orientation = this.otherOrientation(this.orientation);
    document.getElementById(this.kDOMIContainerID).style.MozBoxOrient = this.orientation;
    this.reorientSplitter(this.orientation);
    
    // save state on state change of any open domi window to use when opening any other new domi window
    var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    prefs = prefs.getBranch(this.kPrefBranch);
    prefs.setCharPref(this.kPrefAtom,this.orientation);
  },
  
  otherOrientation: function(orientation) {
    return orientation == this.kOrientHorz ? this.kOrientVert : this.kOrientHorz;
  },

  reorientSplitter: function(orientation) {
    // add/remove attr on splitter so it reflects new state (none in default state, orient="vertical" in stacked orientation)
    var el = document.getElementById(this.kSplitterID);
    el.removeAttribute(this.kAttrOrient);
    if(orientation == this.kOrientVert) {
      el.setAttribute(this.kAttrOrient,this.kAttrOrientVert);
      }
  }

};
window.addEventListener("load", function(e) { com.example.stackedinspector.onLoad(e); }, false);
window.addEventListener("unload", function(e) { com.example.stackedinspector.onUnload(e); }, false);


