/************************************************************************/
/*                                                                      */
/*      Tile Tabs  -  Firefox Extension  -  Customize Toolbar Window    */
/*                                                                      */
/*      Javascript for Customize Toolbar overlay                        */
/*                                                                      */
/*      Copyright (C) 2010-2011  by  DW-dev                             */
/*                                                                      */
/*      Last Edit  -  18 Aug 2011                                       */
/*                                                                      */
/************************************************************************/

var tileTabsCustomizeToolbar =
{
    appInfo: Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo),
    versionComparator: Components.classes["@mozilla.org/xpcom/version-comparator;1"].getService(Components.interfaces.nsIVersionComparator),
    ffVersion: "",

    prefs: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.tiletabs."),

    skinColor: "#5070C0",

    prefsObserver:
    {
        register: function()
        {
            /* Query nsIPrefBranch2 interface to observe changes to pref values */
            tileTabsCustomizeToolbar.prefs.QueryInterface(Components.interfaces.nsIPrefBranch2);

            /* Add the observer */
            tileTabsCustomizeToolbar.prefs.addObserver("",this,false);
        },

        observe: function(subject,topic,data)
        {
            var i;

            if (topic != "nsPref:changed") return;

            tileTabsCustomizeToolbar.skinColor = tileTabsCustomizeToolbar.prefs.getCharPref("skin-color");

            for (i = 0; i < document.styleSheets.length; i++)
            {
                if (document.styleSheets[i].href == "chrome://tiletabs/skin/tiletabs-buttonicon.css")
                    document.styleSheets[i].cssRules[0].style.setProperty("background-color",tileTabsCustomizeToolbar.skinColor,"");
            }
        }
    },

    onLoad: function()
    {
        /* Determine Firefox version */

        tileTabsCustomizeToolbar.ffVersion = "3.6";
        if (tileTabsCustomizeToolbar.versionComparator.compare(tileTabsCustomizeToolbar.appInfo.version,"4.0b1") >= 0) tileTabsCustomizeToolbar.ffVersion = "4.0";

        document.getElementById("CustomizeToolbarWindow").setAttribute("tiletabs-ffversion",tileTabsCustomizeToolbar.ffVersion);

        /* Look for presence of Tile View */

        window.setTimeout(function ()
        {
            if (document.getElementById("CustomizeToolbarWindow").hasAttribute("tileview-ffversion")) tileTabsCustomizeToolbar.onLoadAbandon();
            else tileTabsCustomizeToolbar.onLoadContinue();
        },100);
    },

    onLoadAbandon: function()
    {
        var buttonmenu;

        if ((buttonmenu = document.getElementById("wrapper-tiletabs-buttonmenu")) != null)  /* button already in Customize window */
            buttonmenu.setAttribute("hidden","true");
    },

    onLoadContinue: function()
    {
        var i;

        /* Register preferences observer */

        tileTabsCustomizeToolbar.prefsObserver.register();

        /* Modify style sheet for button icon background color */

        tileTabsCustomizeToolbar.skinColor = tileTabsCustomizeToolbar.prefs.getCharPref("skin-color");

        for (i = 0; i < document.styleSheets.length; i++)
        {
            if (document.styleSheets[i].href == "chrome://tiletabs/skin/tiletabs-buttonicon.css")
                document.styleSheets[i].cssRules[0].style.setProperty("background-color",tileTabsCustomizeToolbar.skinColor,"");
        }
    }    
};

window.addEventListener("load",tileTabsCustomizeToolbar.onLoad,false);
