/************************************************************************/
/*                                                                      */
/*      Tile Tabs  -  Firefox Extension  -  Options Window              */
/*                                                                      */
/*      Javascript for Options dialog                                   */
/*                                                                      */
/*      Copyright (C) 2010-2011  by  DW-dev                             */
/*                                                                      */
/*      Last Edit  -  18 Aug 2011                                       */
/*                                                                      */
/************************************************************************/

var tileTabsOptions =
{
    prefs: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.tiletabs."),

    initPrefs: function()
    {
        var i;
        var checkbox,checkstate;
        var menulist,index;
        var colorpicker,color;
        var keymods = new Array("Shift","Ctrl","Ctrl+Shift","Alt","Alt+Shift","Alt+Ctrl","Alt+Ctrl+Shift");
        var keyfnum = new Array("F1","F2","F3","F4","F5","F6","F7","F8","F9","F10","F11","F12");

        /* Skin Options */
        
        colorpicker = document.getElementById("tiletabs-skin-color");
        try
        {
          color = tileTabsOptions.prefs.getCharPref("skin-color");
          colorpicker.color = color;
        }
        catch(e)
        {
          colorpicker.color = "#5070C0";
        }
        
        /* Tile Options */
        
        menulist = document.getElementById("tiletabs-tile-border");
        for (index = 0; index <= 4; index ++)
        {
          menulist.appendItem(index,index);
        }
        try
        {
          menulist.selectedIndex = tileTabsOptions.prefs.getIntPref("tile-border");
        }
        catch(e)
        {
          menulist.selectedIndex = 2;
        }
        
        checkbox = document.getElementById("tiletabs-tile-syncsel");
        try
        {
          checkstate = tileTabsOptions.prefs.getBoolPref("tile-syncsel");
          checkbox.checked = checkstate;
        }
        catch(e)
        {
          checkbox.checked = false;
        }
        
        /* Splitter Options */
        
        menulist = document.getElementById("tiletabs-splitter-size");
        for (index = 2; index <= 10; index += 2)
        {
          menulist.appendItem(index,index);
        }
        try
        {
          menulist.selectedIndex = (tileTabsOptions.prefs.getIntPref("splitter-size")-2)/2;
        }
        catch(e)
        {
          menulist.selectedIndex = 2;
        }
        
        menulist = document.getElementById("tiletabs-splitter-snap");
        for (index = 10; index <= 30; index += 5)
        {
          menulist.appendItem(index,index);
        }
        try
        {
          menulist.selectedIndex = (tileTabsOptions.prefs.getIntPref("splitter-snap")-10)/5;
        }
        catch(e)
        {
          menulist.selectedIndex = 2;
        }
        
        /* Tab Options */
        
        checkbox = document.getElementById("tiletabs-tab-single");
        try
        {
          checkstate = tileTabsOptions.prefs.getBoolPref("tab-single");
          checkbox.checked = checkstate;
        }
        catch(e)
        {
          checkbox.checked = false;
        }
        
        checkbox = document.getElementById("tiletabs-tab-move");
        try
        {
          checkstate = tileTabsOptions.prefs.getBoolPref("tab-move");
          checkbox.checked = checkstate;
        }
        catch(e)
        {
          checkbox.checked = false;
        }
        
        checkbox = document.getElementById("tiletabs-tab-iconborder");
        try
        {
          checkstate = tileTabsOptions.prefs.getBoolPref("tab-iconborder");
          checkbox.checked = checkstate;
        }
        catch(e)
        {
          checkbox.checked = true;
        }
        
        checkbox = document.getElementById("tiletabs-tab-colortext");
        try
        {
          checkstate = tileTabsOptions.prefs.getBoolPref("tab-colortext");
          checkbox.checked = checkstate;
        }
        catch(e)
        {
          checkbox.checked = false;
        }
        
        checkbox = document.getElementById("tiletabs-tab-italictext");
        try
        {
          checkstate = tileTabsOptions.prefs.getBoolPref("tab-italictext");
          checkbox.checked = checkstate;
        }
        catch(e)
        {
          checkbox.checked = false;
        }
        
        checkbox = document.getElementById("tiletabs-tab-loadhome");
        try
        {
          checkstate = tileTabsOptions.prefs.getBoolPref("tab-loadhome");
          checkbox.checked = checkstate;
        }
        catch(e)
        {
          checkbox.checked = false;
        }
        
        /* Menu Options */
        
        checkbox = document.getElementById("tiletabs-menu-tilemenu");
        try
        {
          checkstate = tileTabsOptions.prefs.getBoolPref("menu-tilemenu");
          checkbox.checked = checkstate;
        }
        catch(e)
        {
          checkbox.checked = true;
        }
        
        checkbox = document.getElementById("tiletabs-menu-tile");
        try
        {
          checkstate = tileTabsOptions.prefs.getBoolPref("menu-tile");
          checkbox.checked = checkstate;
        }
        catch(e)
        {
          checkbox.checked = true;
        }
        
        checkbox = document.getElementById("tiletabs-menu-tilenew");
        try
        {
          checkstate = tileTabsOptions.prefs.getBoolPref("menu-tilenew");
          checkbox.checked = checkstate;
        }
        catch(e)
        {
          checkbox.checked = true;
        }
        
        checkbox = document.getElementById("tiletabs-menu-tiledup");
        try
        {
          checkstate = tileTabsOptions.prefs.getBoolPref("menu-tiledup");
          checkbox.checked = checkstate;
        }
        catch(e)
        {
          checkbox.checked = true;
        }
        
        checkbox = document.getElementById("tiletabs-menu-tilelink");
        try
        {
          checkstate = tileTabsOptions.prefs.getBoolPref("menu-tilelink");
          checkbox.checked = checkstate;
        }
        catch(e)
        {
          checkbox.checked = true;
        }
        
        checkbox = document.getElementById("tiletabs-menu-untile");
        try
        {
          checkstate = tileTabsOptions.prefs.getBoolPref("menu-untile");
          checkbox.checked = checkstate;
        }
        catch(e)
        {
          checkbox.checked = true;
        }
        
        checkbox = document.getElementById("tiletabs-menu-switch");
        try
        {
          checkstate = tileTabsOptions.prefs.getBoolPref("menu-switch");
          checkbox.checked = checkstate;
        }
        catch(e)
        {
          checkbox.checked = true;
        }
        
        checkbox = document.getElementById("tiletabs-menu-expand");
        try
        {
          checkstate = tileTabsOptions.prefs.getBoolPref("menu-expand");
          checkbox.checked = checkstate;
        }
        catch(e)
        {
          checkbox.checked = true;
        }
        
        checkbox = document.getElementById("tiletabs-menu-tileall");
        try
        {
          checkstate = tileTabsOptions.prefs.getBoolPref("menu-tileall");
          checkbox.checked = checkstate;
        }
        catch(e)
        {
          checkbox.checked = true;
        }
        
        checkbox = document.getElementById("tiletabs-menu-untileall");
        try
        {
          checkstate = tileTabsOptions.prefs.getBoolPref("menu-untileall");
          checkbox.checked = checkstate;
        }
        catch(e)
        {
          checkbox.checked = true;
        }
        
        /* Function Key Options */
        
        menulist = document.getElementById("tiletabs-fkey-expand-mods");
        for (i = 0; i < 7; i++) menulist.appendItem(keymods[i],i+1);
        try
        {
            menulist.selectedIndex = tileTabsOptions.prefs.getIntPref("fkey-expandtile") >> 4;
        }
        catch(e)
        {
            menulist.selectedIndex = 0;
        }
        menulist = document.getElementById("tiletabs-fkey-expand-fnum");
        for (i = 0; i < 12; i++) menulist.appendItem(keyfnum[i],i+1);
        try
        {
            menulist.selectedIndex = tileTabsOptions.prefs.getIntPref("fkey-expandtile") & 0x0F;
        }
        catch(e)
        {
            menulist.selectedIndex = 2;
        }
        
        menulist = document.getElementById("tiletabs-fkey-sync-mods");
        for (i = 0; i < 7; i++) menulist.appendItem(keymods[i],i+1);
        try
        {
            menulist.selectedIndex = tileTabsOptions.prefs.getIntPref("fkey-syncscroll") >> 4;
        }
        catch(e)
        {
            menulist.selectedIndex = 0;
        }
        menulist = document.getElementById("tiletabs-fkey-sync-fnum");
        for (i = 0; i < 12; i++) menulist.appendItem(keyfnum[i],i+1);
        try
        {
            menulist.selectedIndex = tileTabsOptions.prefs.getIntPref("fkey-syncscroll") & 0x0F;
        }
        catch(e)
        {
            menulist.selectedIndex = 8;
        }
        
        menulist = document.getElementById("tiletabs-fkey-view-mods");
        for (i = 0; i < 7; i++) menulist.appendItem(keymods[i],i+1);
        try
        {
            menulist.selectedIndex = tileTabsOptions.prefs.getIntPref("fkey-viewnormal") >> 4;
        }
        catch(e)
        {
            menulist.selectedIndex = 0;
        }
        menulist = document.getElementById("tiletabs-fkey-view-fnum");
        for (i = 0; i < 12; i++) menulist.appendItem(keyfnum[i],i+1);
        try
        {
            menulist.selectedIndex = tileTabsOptions.prefs.getIntPref("fkey-viewnormal") & 0x0F;
        }
        catch(e)
        {
            menulist.selectedIndex = 9;
        }
        
        tileTabsOptions.onFnumChange("expand");
        tileTabsOptions.onFnumChange("sync");
        tileTabsOptions.onFnumChange("view");
        
        /* Drag Options */
                
        menulist = document.getElementById("tiletabs-drag-tiling");
        for (i = 0; i < 7; i++) menulist.appendItem(keymods[i],i+1);
        try
        {
            menulist.selectedIndex = tileTabsOptions.prefs.getIntPref("drag-tiling");
        }
        catch(e)
        {
            menulist.selectedIndex = 2;
        }
        
        checkbox = document.getElementById("tiletabs-drag-tablink");
        try
        {
            checkstate = tileTabsOptions.prefs.getBoolPref("drag-tablink");
            checkbox.checked = checkstate;
        }
        catch(e)
        {
            checkbox.checked = true;
        }
        
        /* Button Options */
        
        menulist = document.getElementById("tiletabs-button-none");
        try
        {
          menulist.selectedIndex = tileTabsOptions.prefs.getIntPref("button-none");
        }
        catch(e)
        {
          menulist.selectedIndex = 0;
        }
        
        menulist = document.getElementById("tiletabs-button-some");
        try
        {
          menulist.selectedIndex = tileTabsOptions.prefs.getIntPref("button-some");
        }
        catch(e)
        {
          menulist.selectedIndex = 0;
        }
        
        menulist = document.getElementById("tiletabs-button-all");
        try
        {
          menulist.selectedIndex = tileTabsOptions.prefs.getIntPref("button-all");
        }
        catch(e)
        {
          menulist.selectedIndex = 0;
        }
        
        /* Restore Options */
        
        checkbox = document.getElementById("tiletabs-restore-layout");
        try
        {
          checkstate = tileTabsOptions.prefs.getBoolPref("restore-layout");
          checkbox.checked = checkstate;
        }
        catch(e)
        {
          checkbox.checked = true;
        }
    },

    savePrefs: function()
    {
        /* Skin Options */
        
        tileTabsOptions.prefs.setCharPref("skin-color",document.getElementById("tiletabs-skin-color").color);
        
        /* Tile Options */
        
        tileTabsOptions.prefs.setIntPref("tile-border",document.getElementById("tiletabs-tile-border").value);
        tileTabsOptions.prefs.setBoolPref("tile-syncsel",document.getElementById("tiletabs-tile-syncsel").checked);
        
        /* Splitter Options */
        
        tileTabsOptions.prefs.setIntPref("splitter-size",document.getElementById("tiletabs-splitter-size").value);
        tileTabsOptions.prefs.setIntPref("splitter-snap",document.getElementById("tiletabs-splitter-snap").value);
        
        /* Tab Options */
        
        tileTabsOptions.prefs.setBoolPref("tab-single",document.getElementById("tiletabs-tab-single").checked);
        tileTabsOptions.prefs.setBoolPref("tab-move",document.getElementById("tiletabs-tab-move").checked);
        tileTabsOptions.prefs.setBoolPref("tab-iconborder",document.getElementById("tiletabs-tab-iconborder").checked);
        tileTabsOptions.prefs.setBoolPref("tab-colortext",document.getElementById("tiletabs-tab-colortext").checked);
        tileTabsOptions.prefs.setBoolPref("tab-italictext",document.getElementById("tiletabs-tab-italictext").checked);
        tileTabsOptions.prefs.setBoolPref("tab-loadhome",document.getElementById("tiletabs-tab-loadhome").checked);
        
        /* Menu Options */
        
        tileTabsOptions.prefs.setBoolPref("menu-tilemenu",document.getElementById("tiletabs-menu-tilemenu").checked);
        tileTabsOptions.prefs.setBoolPref("menu-tile",document.getElementById("tiletabs-menu-tile").checked);
        tileTabsOptions.prefs.setBoolPref("menu-tilenew",document.getElementById("tiletabs-menu-tilenew").checked);
        tileTabsOptions.prefs.setBoolPref("menu-tiledup",document.getElementById("tiletabs-menu-tiledup").checked);
        tileTabsOptions.prefs.setBoolPref("menu-tilelink",document.getElementById("tiletabs-menu-tilelink").checked);
        tileTabsOptions.prefs.setBoolPref("menu-untile",document.getElementById("tiletabs-menu-untile").checked);
        tileTabsOptions.prefs.setBoolPref("menu-switch",document.getElementById("tiletabs-menu-switch").checked);
        tileTabsOptions.prefs.setBoolPref("menu-expand",document.getElementById("tiletabs-menu-expand").checked);
        tileTabsOptions.prefs.setBoolPref("menu-tileall",document.getElementById("tiletabs-menu-tileall").checked);
        tileTabsOptions.prefs.setBoolPref("menu-untileall",document.getElementById("tiletabs-menu-untileall").checked);
        
        /* Function Key Options */
        
        tileTabsOptions.prefs.setIntPref("fkey-expandtile",document.getElementById("tiletabs-fkey-expand-mods").value << 4 |
                                                           document.getElementById("tiletabs-fkey-expand-fnum").value);
        tileTabsOptions.prefs.setIntPref("fkey-syncscroll",document.getElementById("tiletabs-fkey-sync-mods").value << 4 |
                                                           document.getElementById("tiletabs-fkey-sync-fnum").value);
        tileTabsOptions.prefs.setIntPref("fkey-viewnormal",document.getElementById("tiletabs-fkey-view-mods").value << 4 |
                                                          document.getElementById("tiletabs-fkey-view-fnum").value);
                                                          
        /* Drag Options */
        
        tileTabsOptions.prefs.setIntPref("drag-tiling",document.getElementById("tiletabs-drag-tiling").value);
        tileTabsOptions.prefs.setBoolPref("drag-tablink",document.getElementById("tiletabs-drag-tablink").checked);
        
        /* Button Options */
        
        tileTabsOptions.prefs.setIntPref("button-none",document.getElementById("tiletabs-button-none").value);
        tileTabsOptions.prefs.setIntPref("button-some",document.getElementById("tiletabs-button-some").value);
        tileTabsOptions.prefs.setIntPref("button-all",document.getElementById("tiletabs-button-all").value);
        
        /* Restore Options */
        
        tileTabsOptions.prefs.setBoolPref("restore-layout",document.getElementById("tiletabs-restore-layout").checked);
    },

    onFnumChange: function(key)
    {
        if (document.getElementById("tiletabs-fkey-" + key + "-fnum").value == 0)
        {
            document.getElementById("tiletabs-fkey-" + key + "-mods").setAttribute("disabled","true");
            document.getElementById("tiletabs-fkey-" + key + "-mods").selectedIndex = 0;
        }
        else
        {
            document.getElementById("tiletabs-fkey-" + key + "-mods").removeAttribute("disabled");
        }
    }
};
