/**
 *  browser.js
 *  Copyright (C) 2007-2011  GNUCITIZEN
 *  
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

XULBrowserWindow.inContentWhitelist.push('chrome://org.gnucitizen.websecurify.firefox/content/imp/content/mainPage.html');

/* ------------------------------------------------------------------------ */

function handleWebsecurifyOpenPanelCommandEvent(event) {
	switchToTabHavingURI('about:websecurify', true);
}

function handleWebsecurifyPopupPanelPopupshowingEvent(event) {
	document.getElementById('websecurify-firefox-browser-popup-iframe').contentWindow.location.reload();
}

/* ------------------------------------------------------------------------ */

function websecurifyAddToolbarbutton() {
	let $navBar = document.getElementById('nav-bar');
	let currentSetArray = $navBar.currentSet.split(',');
	
	if (currentSetArray.indexOf('websecurify-firefox-browser-websecurify-toolbarbutton') < 0) {
	 	currentSetArray.push('websecurify-firefox-browser-websecurify-toolbarbutton');
		
		let currentSet = currentSetArray.join(',');
		
		$navBar.setAttribute('currentset', currentSet);
		
		$navBar.currentSet = currentSet;
		
		document.persist('nav-bar', 'currentset');
	}
}

/* ------------------------------------------------------------------------ */

function handleWebsecurifyFirstrun() {
	websecurifyAddToolbarbutton();
}

function handleWebsecurifyUpgrade() {
	websecurifyAddToolbarbutton();
}

function handleWebsecurifyReinstall() {
	websecurifyAddToolbarbutton();
}

/* ------------------------------------------------------------------------ */

function handleWebsecurifyDOMContentLoadedEvent(event) {
	if (event.target != document) {
		return;
	}
	
	let firstrun;
	
	try {
		firstrun = Services.prefs.getBoolPref('org.gnucitizen.websecurify.firefox.firstrun');
	} catch (e) {
		firstrun = true;
	}
	
	Application.getExtensions(function(extensions) {
		let currentVersion = extensions.get('firefox@websecurify.gnucitizen.org').version;
		
		if (firstrun) {
			Services.prefs.setBoolPref('org.gnucitizen.websecurify.firefox.firstrun', false);
			Services.prefs.setCharPref('org.gnucitizen.websecurify.firefox.installedVersion', currentVersion);
			
			handleWebsecurifyFirstrun();
		} else {
			try {
				let installedVersion = Services.prefs.getCharPref('org.gnucitizen.websecurify.firefox.installedVersion');
				
				if (currentVersion > installedVersion) {
					Services.prefs.setCharPref('org.gnucitizen.websecurify.firefox.installedVersion', currentVersion);
					
					handleWebsecurifyUpgrade();
				}
			} catch (e) {
				handleWebsecurifyReinstall();
			}
		}
	});
	
	let lookandfeel;
	
	let xulRuntime = Components.classes['@mozilla.org/xre/app-info;1'].getService(Components.interfaces.nsIXULRuntime);
	
	switch (xulRuntime.OS) {
		case 'Darwin':
			lookandfeel = 'Mac';
			
			break;
		case 'WINNT':
			lookandfeel = 'Windows';
			
			break;
		case 'Linux':
			lookandfeel = 'Linux';
			
			break;
		default:
			lookandfeel = 'Undefined';
	}
	
	let $popupPanel = document.getElementById('websecurify-firefox-browser-popup-panel');
	
	$popupPanel.setAttribute('lookandfeel', lookandfeel);
}

addEventListener('DOMContentLoaded', handleWebsecurifyDOMContentLoadedEvent, false);

/*  GNUCITIZEN (Information Security Think Tank)
 **********************************************/