/**
 *  backgroundPage.js
 *  Copyright (C) 2007-2011  GNUCITIZEN
 *  
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

Components.utils.import('resource://gre/modules/XPCOMUtils.jsm');

/* ------------------------------------------------------------------------ */

XPCOMUtils.defineLazyServiceGetter(window, 'windowMediator', '@mozilla.org/appshell/window-mediator;1', 'nsIWindowMediator');
XPCOMUtils.defineLazyServiceGetter(window, 'observerService', '@mozilla.org/observer-service;1', 'nsIObserverService');

/* ------------------------------------------------------------------------ */

var mainObserver = {
	observe: function (subject, topic, data) {
		if (topic == 'xul-window-destroyed') {
			let enumerator = windowMediator.getXULWindowEnumerator(null);
			
			let counter = 0;
			
			while (enumerator.hasMoreElements()) {
				enumerator.getNext();
				
				counter += 1;
			}
			
			if (counter <= 2) {
				close();
			}
		}
	}
};

/* ------------------------------------------------------------------------ */

function handleDOMContentLoadedEvent(event) {
	if (event.target != document) {
		return;
	}
	
	observerService.addObserver(mainObserver, 'xul-window-destroyed', false);
}

addEventListener('DOMContentLoaded', handleDOMContentLoadedEvent, false);

function handleUnloadEvent(event) {
	if (event.target != document) {
		return;
	}
	
	observerService.removeObserver(mainObserver, 'xul-window-destroyed');
}

addEventListener('unload', handleUnloadEvent, false);

/*  GNUCITIZEN (Information Security Think Tank)
 **********************************************/